django/config/urls.py
from django.contrib import admin
from django.urls import path, include
urlpatterns = [
    path('admin/', admin.site.urls),
    path('tests/', include('testapp.urls')),
    path('servers/', include('serverapp.urls')),
    path('students/', include('studentapp.urls')),
]

django/serverapp/urls.py
from django.urls import path
from . import views

app_name = 'server'
urlpatterns = [
    path('', views.index),
    path('<int:server_id>/', views.detail, name='detail'),
    path('<int:server_id>/create', views.create),
    path('<int:server_id>/delete', views.delete),
    path('<int:server_id>/reset', views.delete),
]

django/studentapp/urls.py
from django.urls import path
from . import views
urlpatterns = [
    path('', views.index)
    
]

django/testapp/urls.py
from django.urls import path
from . import views

app_name = 'test'

urlpatterns = [
    path('', views.index),
    path('<int:test_id>/', views.detail, name='detail'),
]

django/serverapp/models.py
from django.db import models

# Create your models here.
class Server(models.Model):
    server_ip = models.CharField(max_length=20)
    ssh_port = models.CharField(max_length=10, default='22')
    server_root_passwd = models.CharField(max_length=20)
    status = models.CharField(max_length=10, default='dead')
    def __str__(self):
        return self.server_ip

django/studentapp/models.py
from django.db import models
from testapp.models import Test
from serverapp.models import Server
# Create your models here.
class Student(models.Model):
    student_id = models.CharField(max_length=10, unique=True)
    test = models.ForeignKey(Test, null=True, on_delete=models.CASCADE)
    server = models.ForeignKey(Server, null=True, on_delete=models.SET_NULL)
    def __str__(self):
        return self.student_id

django/testapp/models.py
from django.db import models

# Create your models here.

class Test(models.Model):
    name = models.CharField(max_length=20)
    def __str__(self):
        return self.name

class Common(models.Model):
    name = models.CharField(max_length=100)
    answer = models.CharField(max_length=100)
    command = models.TextField()
    test = models.ForeignKey(Test, null=True, on_delete=models.CASCADE)
    class Meta():
        abstract = True
    def __str__(self):
        return self.name

class QuestionTwo(Common):
    pass

class QuestionThree(Common):
    attribute_1 = models.CharField(max_length=100)

class QuestionFour(Common):
    attribute_1 = models.CharField(max_length=100)
    attribute_2 = models.CharField(max_length=100)

django/serverapp/views.py
from django.shortcuts import render
from django.http import HttpResponse
from .models import Server
import subprocess

# func
def check_server_status(root_passwd, server_ip, ssh_port):
    # 주의사항 : 맨 앞에 띄어쓰기 있어야함
    cmd = " systemctl is-active sshd.service"
    try:         
        out = subprocess.check_output(["ssh", "-o", "ConnectTimeout=1", "root@" + server_ip, "-p", ssh_port, cmd], encoding='utf-8')
    except:
        out = 'dead'
    return out

def create_server_using_vagrant(root_passwd, server_ip, ssh_port):
    #cmd = "sshpass -p 'dclabroot311!' scp -P 6151 -o StrictHostKeyChecking=no /home/ubuntu/Projects/vm-manage/Vagrantfile root@113.198.137.97:/root/Vagrantfile"
    out = subprocess.check_output(["sshpass -p " + root_passwd + " scp -P " + ssh_port + " -o StrictHostKeyChecking=no /home/ubuntu/Projects/vm-manage/Vagrantfile root@" + server_ip + ":/root/Vagrantfile"], shell=True, encoding='utf-8')

    cmd = " vagrant up"
    out = subprocess.check_output(["sshpass -p " + root_passwd + " ssh root@" + server_ip + " -p " + ssh_port + cmd], shell=True, encoding='utf-8')
# Create your views here.
def index(request):
    servers = Server.objects.all()
    for server in servers:
        try:
            out = check_server_status(server.server_root_passwd, server.server_ip, server.ssh_port)
        except:
            out = 'dead'
        server.status = out
        server.save()
    context = {'servers': servers}
    return render(request, 'serverapp/server_list.html', context)

def detail(request, server_id):
    server = Server.objects.get(id=server_id)
    context = {'server': server}
    return render(request, 'serverapp/server_detail.html', context)

def create(request, server_id):
    server = Server.objects.get(id=server_id)
    create_server_using_vagrant(server.server_root_passwd, server.server_ip, server.ssh_port)

    return HttpResponse(f'create vm at: {server.server_ip}')

def delete(request, server_id):
    server = Server.objects.get(id=server_id)
    return HttpResponse(f'delete vm at: {server.server_ip}')

def reset(request, server_id):
    server = Server.objects.get(id=server_id)
    return HttpResponse(f'reset vm at: {server.server_ip}')

django/studentapp/views.py
from django.shortcuts import render
from .models import Student
# Create your views here.
def index(request):
    students = Student.objects.all()
    context = {'students': students}
    return render(request, 'studentapp/student_list.html', context)

django/testapp/views.py
from django.shortcuts import render
from django.http import HttpResponse
from .models import Test
# Create your views here.
def index(request):
    tests = Test.objects.all()
    context = {'tests': tests}
    return render(request, 'testapp/test_list.html', context)

def detail(request, test_id):
    test = Test.objects.get(id=test_id)
    context = {'test': test}
    return render(request, 'testapp/test_detail.html', context)

django/templates/serverapp/server_detail.html
<html>
	<head>
	</head>
	<body>
		<h1>서버 정보</h1>
		{% if server %}
        <div style="width:200px; float:left; margin-left:20px; border:1px solid black;">
			ip주소 : {{ server.server_ip }}
			<br>
			ssh 포트 : {{ server.ssh_port }}
			<br>
			root패스워드 : {{ server.server_root_passwd }}
			<!--<a href='http://localhost:8000/accounts/' name='{{ server.ip_addr }}'>계정요청</a>-->
		</div>
		{% endif %}
	</body>
</html>

django/templates/serverapp/server_list.html
<html>
	<head>
	</head>
	<body>
		<h1>서버 목록</h1>
		{% if servers %}
			{% for server in servers %}
			<div style="width:200px; float:left; margin-left:20px; border:1px solid black;">
				ip주소 : {{ server.server_ip }}
				<br>
				ssh 포트 : {{ server.ssh_port }}
				<br>
				root패스워드 : {{ server.server_root_passwd }}
				<br>
				상태 : {{ server.status }}
				<br>
				<a href="{% url 'server:detail' server.id %}">상세정보</a>
			</div>
			{% endfor %}
		{% endif %}
	</body>
</html>

django/templates/studentapp/student_list.html
<html>
	<head>
	</head>
	<body>
		<h1>학생 목록</h1>
		{% if students %}
			{% for student in students %}
			<div style="width:200px; float:left; margin-left:20px; border:1px solid black;">
				학번 : {{ student.student_id }}
				<br>
				할당된 서버 : 
                <a href="/servers/{{ student.server.id}}" >{{ student.server.server_ip }}</a>
				<br>
				할당된 시험 : {{ student.test }}
				<!--<a href='http://localhost:8000/accounts/' name='{{ server.ip_addr }}'>계정요청</a>-->
			</div>
			{% endfor %}
		{% endif %}
	</body>
</html>

django/templates/testapp/test_detail.html
<html>
	<head>
	</head>
	<body>
		<h1>Test 정보</h1>
		{% if test %}
        <div style="width:200px; float:left; margin-left:20px; border:1px solid black;">
			Test 이름 : {{ test.name }}
			<br>
		</div>
		{% endif %}
	</body>
</html>

django/templates/testapp/test_list.html
<html>
	<head>
	</head>
	<body>
		<h1>서버 목록</h1>
		{% if tests %}
			{% for test in tests %}
			<div style="width:200px; float:left; margin-left:20px; border:1px solid black;">
				test 이름: {{ test.name }}
				<br>
				<a href="{% url 'test:detail' test.id %}">상세정보</a>
			</div>
			{% endfor %}
		{% endif %}
	</body>
</html>